//************************************************************
//               ASCII binary to binary conversion
//************************************************************
// Reference: Software Solutions
//            Chapter 1
// File name: ASCBTODE
//
// Description:
//            A string of binary digits is stored in
//            an array of type char. The digit string
//            is converted to binary and stored in a
//            variable of type unsigned long

#include <iostream.h>
#include <math.h>

// Prototypes
unsigned long AscBin2Bin(char[]);

main()
{
   unsigned long result;
   char binDigits[] = {"11001100-10101010"};
   int size;


   // Display binary
   cout << "\n\n\n";
   cout << "Binary digits: " << binDigits;

   // Call conversion function
   result = AscBin2Bin(binDigits);

   // Display result
   cout << "\nBinary value: " << result ;

  return 0;

}


unsigned long AscBin2Bin( char digits[])
// Function to convert string of binary digits to a binary
// value
// Pre:
//    digits[] is a char array of binary digits.
//    The array can contain spaces and dashes as
//    separators.
// Post:
//    Returns the binary value of the digits
//    in a variable of type unsigned long
//
{

     int size = 0;                  // Array size
     unsigned long binWeight = 1;   // Binary digit weight
     unsigned long accumulator = 0; // Temp value
     unsigned int bitOffset;        // Offset in bit array
     unsigned int digitPos = 0;     // Relative digit position

     // Calculate array size
     while(digits[size])
	size++;

     // Routine starts at the least significant digit, which
     // has a weight of 1. The weight of other digits to the
     // left of the first one is 2 * the weight of the
     // previous bit
     for(int counter = 0; counter < size; counter++)
     {
	bitOffset = (size - 1) - digitPos;

	if(digits[bitOffset] == ' ' || digits[bitOffset] == '-')
	{
	   digitPos++;
	   continue;
	}

	// Test for 1-digit and add weight to accumulator
	if(digits[bitOffset] == '1')
	  accumulator = accumulator + binWeight;
	// Update digit weight
	binWeight *= 2;
	// Update digit position in string
	digitPos++;
     }
     return accumulator;

}


