//************************************************************
//                Binary to decimal conversion
//************************************************************
// Reference: Numerical Solutions
//            Chapter 1
//
// Description:
//            A set of binary digits is stored in
//            an array of type char. The binary value
//            of the digits  are converted to decimal
//            and stored in a variable of type int

#include <iostream.h>
#include <math.h>

// Prototypes
unsigned long bin2dec(char[], int);

main()
{
   unsigned long result;
   char binDigits[] = "11001100-10101010";
   int size;


   // Display binary
   cout << "\n\n\n";
   cout << "Binary value: " << binDigits;

   // Convert to decimal
   size = (sizeof(binDigits) / sizeof(binDigits[0])) - 1;

   // Call conversion function
   result = bin2dec(binDigits, size);

   // Display result
   cout << "\nDecimal value is: " << result ;

  return 0;

}


unsigned long bin2dec( char digits[], int arraySize )
// Function to convert binary digits to a decimal
// value stored in an int variable
// Pre:
//    digits[] is a char array of binary 0 or 1
//    bits. The array can contain spaces or dashes
//    as separators.
//    arraySize is the number of elements in the
//    array, excluding the terminator character
// Post:
//    Returns the decimal value of the digits
//    in the binary array
//
{

     unsigned long binWeight = 1;   // Binary digit weight
     unsigned long accumulator = 0; // Temp value
     unsigned int bitOffset;        // Offset in bit array
     unsigned int digitPos = 0;     // Relative digit position

     // Routine starts at the least significant bit, which
     // has a weight of 0. The weight of other bits to the
     // left of the first one is 2 * the weight of the
     // previous bit
     for(int counter = 0; counter < arraySize; counter++)
     {
	bitOffset = (arraySize - 1) - digitPos;

	if(digits[bitOffset] == ' ' || digits[bitOffset] == '-')
	{
	   digitPos++;
	   continue;
	}

	if(digits[bitOffset] == '1')
	   accumulator = accumulator + binWeight;

	binWeight *= 2;
	digitPos++;
     }
     return accumulator;

}


