//************************************************************
//          Identifying the processor type 
//************************************************************
// Reference:   SOFTWARE SOLUTIONS - Chapter 3
// Workspace  : Chapter3\Id CPU
// Entry point: Id CPU.cpp
// Other files: support.cpp
//              support.h
// Development: Visual C++ 6.0 Console Application
// Date:        December 28/2000
//
// Description:
//              Program exercising the function IdCpu()
//              in support.cpp
//***********************************************************
#include "stdafx.h"
#include <iostream.h>
#include "support.h"
#include <conio.h>
#include <stdio.h>
#include <iomanip.h>

int main()
{
    int dummy;
    int machType = 0;
	int cpuId = 0;
	int steping = 0;
	int model = 0;
	int family = 0;

    cout << "\nIdentifying processor type\n";
	cout << "1 = 8086\n";
	cout << "2 = 80286\n";
	cout << "3 = 386\n";
	cout << "4 = 486\n";
	cout << "5 = Pentium\n\n";
    
	// Call function
	IdCpu(&machType, &cpuId);
    
	// Report results
	cout << "This machine type: " << machType << "\n";
	if(cpuId)
	{
		cout << "ID string: GenuineIntel" << "\n";
        cout << "Intel Pentium CPU ID code: " << cpuId << "\n";
		steping = cpuId & 0xf;
        cout << "  Stepping code: " << steping << "\n";
		model = (cpuId & 0xf0) >> 4;
		cout << "  Model code: " << model << "\n";
		family = (cpuId & 0xf00) >> 8;
		cout << "  Family code: " << family << "\n";
    }

	cin >> dummy;
	return 0;
}

