//************************************************************
//     Test module for BCD arithmetic in bcd12math.cpp
//************************************************************
// Reference:   SOFTWARE SOLUTIONS Chater2/4
// Workspace  : Chapter2\BCD Tests
//
// Entry point: BCD Tests.cpp
// Other files: bcd12math.cpp
//              bcd12math.h
// Development: Visual C++ 6.0 Console Application
// Date:        December 23/2000
//
// Description:
//          Driver module for exercising BCD conversions and
//          arithmetic in bcd12math.cpp
//***********************************************************
#include "stdafx.h"
#include <iostream.h>
#include <iomanip.h>
#include "bcd12math.h"
#include <stdio.h>


//**********************************
//           global data
//**********************************
// Arrays for user input
char user1[28];
char user2[28];

// BCD12 variables
char num1[12];
char num2[12];
char bcdResult[12];

// ASCII data
char op1[32];
char op2[32];
char ascResult[32];


//*********************************
//       driver function
//*********************************
int main()
{

int selection = 0;

  while(selection != 8)
  {
    // Program menu
	cout << "\n\nOPERATIONS: ";
	cout << "\n  1. Conversion routines";
	cout << "\n  2. Addition";
	cout << "\n  3. Subtration";
	cout << "\n  4. Multiplication";
	cout << "\n  5. Division";
	cout << "\n  8. Exit";
	cout << "\n     Select: ";
	cin >> selection;

	switch(selection)
	{
	case 1:
	// Testing BCD conversion function
	cout << "\n\nTesting ASCII/BCD conversions in BCD12math.cpp";
	cout << "\nInput can be decimal or exponential notation (i.e. -1.2E-4)";
	cout << "\nInput string can be up to 27-charaters long";
	cout << "\nIn decimal notation, commas can be used as separators";
    cout << "\n\nEnter number : ";
    cout << flush;                // flush the stream
	// Read input
	gets(user1);
	// Echo input
	cout << "\nUser entered : " << user1;
    // Convert to BCD
	AsciiToBcd12(user1, num1);
	// BCD back to ASCII
	Bcd12ToAscStr(num1, op1);
	// Display result
    cout << "\ndecoded BCD  : " << op1 << "\n";
	break;

	//****************************
	//       BCD addition
	//****************************
	case 2:
	cout << "\n\nTesting signed BCD addition function in BCD12math.cpp";
	cout << "\nInput can be decimal or exponential notation (i.e. -1.2E-4)";
	cout << "\nEach input string can be up to 27-charaters long";
    cout << "\n\nFirst addend    : ";
	cout << flush;               // Flush output stream
	// Read first keyboard string
    gets(user1); 
	// Convert to BCD
	AsciiToBcd12(user1, num1);
	// Prompt
    cout << "Second addend   : ";
    cout << flush;               // Flush stream
    gets(user2); 
    // Convert to BCD
	AsciiToBcd12(user2, num2);
    // Add
    SignAddBcd12(num1, num2, bcdResult);
	// Display result
	Bcd12ToAscStr(bcdResult, ascResult);
    cout << "Sum             : " << ascResult << "\n";
	break;

	//****************************
	//       BCD subtraction
	//****************************
	case 3:
	cout << "\n\nTesting signed BCD subtraction function in BCD12math.cpp";
	cout << "\nInput can be decimal or exponential notation (i.e. -1.2E-4)";
	cout << "\nEach input string can be up to 27-charaters long";
    cout << "\n\nMinuend      : ";
	cout << flush;               // Flush output stream
	// Read first keyboard string
    gets(user1); 
	// Convert to BCD
	AsciiToBcd12(user1, num1);
	// Prompt
    cout << "Subtrahend   : ";
    cout << flush;               // Flush stream
    gets(user2); 
    // Convert to BCD
	AsciiToBcd12(user2, num2);
    // Add
    SignSubBcd12(num1, num2, bcdResult);
	// Display result
	Bcd12ToAscStr(bcdResult, ascResult);
    cout << "Difference   : " << ascResult << "\n";
	break;


	//****************************
	//    BCD multiplication
	//****************************
	case 4:
	cout << "\n\nTesting signed BCD multiplication function in BCD12math.cpp";
	cout << "\nInput can be decimal or exponential notation (i.e. -1.2E-4)";
	cout << "\nEach input string can be up to 27-charaters long";
    cout << "\n\nMultiplicand    : ";
	cout << flush;               // Flush output stream
	// Read first keyboard string
    gets(user1); 
	// Convert to BCD
	AsciiToBcd12(user1, num1);
	// Prompt
    cout << "Multiplier      : ";
    cout << flush;               // Flush stream
    gets(user2); 
    // Convert to BCD
	AsciiToBcd12(user2, num2);
    // Add
    SignMulBcd12(num1, num2, bcdResult);
	// Display result
	Bcd12ToAscStr(bcdResult, ascResult);
    cout << "Product         : " << ascResult << "\n";
	break;

	//****************************
	//       BCD division
	//****************************
	case 5:
	cout << "\n\nTesting signed BCD division function in BCD12math.cpp";
	cout << "\nInput can be decimal or exponential notation (i.e. -1.2E-4)";
	cout << "\nEach input string can be up to 27-charaters long";
    cout << "\n\nDivisor         : ";
	cout << flush;               // Flush output stream
	// Read first keyboard string
    gets(user1); 
	// Convert to BCD
	AsciiToBcd12(user1, num1);
	// Prompt
    cout << "Dividend        : ";
    cout << flush;               // Flush stream
    gets(user2); 
    // Convert to BCD
	AsciiToBcd12(user2, num2);
    // Add
    SignDivBcd12(num1, num2, bcdResult);
	// Display result
	Bcd12ToAscStr(bcdResult, ascResult);
    cout << "Quotient        : " << ascResult << "\n";
	break;

    //*****************************
	//      invalid input
	//*****************************
	default:
        if(selection == 8)
			break;
		cout << "\nINVALID SELECTION\n";

  }
 }
  return 0;
}

