//************************************************************
//        Testing math unit input and output functions
//************************************************************
// Reference:   SOFTWARE SOLUTIONS
// Workspace  : Chapter6\Test Mu32_4
// Entry point: Test Mu32_4t
// Other files: Un32_4.lib
//              Un32_4.h
// Development: Visual C++ 6.0 Console Application
// Date:        January 12/2001
//
// Description:
//              Tests for conversion functions in the Un32_4
//              module of math32.lib
//              Tested functions:
//                int FpuInput(char[])
//                void AsciiToExp(char[], char[])
//                int FpuOutput(char[])
//************************************************************
#include "stdafx.h"
#include "Un32_4.h"
#include <iostream.h>


int main()
{

// Storage for test data 
char userIn[27];      // User input buffer
char numBuf[27];      // ST(0) string
char expBuf[27];      // Exponential notation buffer
int errorCode = 0;    
int regTag;
char tagMsg[8];

    cout << "Testing floating-point conversion functions";
	cout << " in Un32_4.obj";
	cout << "\nInput can be decimal or exponential form";
    cout << "\n\nEnter value: ";
    cin.getline(userIn, 27);
	cout << "\nValue entered: " << userIn << "\n";

    // Move user input to math unit stack top
    errorCode = FpuInput(userIn);   // Call C interface function
REDO:
    switch(errorCode)
	{
	case 1:
		cout << "\nString not in exponential notation";
		cout << "\nCalling AsciiToExp() function";
        AsciiToExp(userIn, expBuf);
        cout << "\nReloading math unit ST(0)";
		errorCode = FpuInput(expBuf);
		goto REDO; 
		break;
	case 2:
		cout << "\nExponent overflow or underflow";
		break;
	case 3:
		cout << "\nInvalid character in string";
		break;
    } 
	// Convert math unit stack top to ASCII
    errorCode = FpuOutput(numBuf);
    if(errorCode)
		cout << "\nError in stack top";

    // Display ASCII
    cout << "\nST(0) is: " << numBuf;

	// Get tag code for stack top register
	regTag = TagCode(0, tagMsg);
	cout << "\nRegister ST(0) has tag code: ";
	cout << tagMsg << "\n\n";

	return 0;
}

