//************************************************************
//           Simple conversion functions
//************************************************************
// Reference:   SOFTWARE SOLUTIONS
// Workspace  : Chapter1\Test Un32_1
// Entry point: Test Un32_1
// Other files: math32_1.lib
//              math32.h
// Development: Visual C++ 6.0 Console Application
// Date:        January 12/2001
//
// Description:
//              Header file for conversion functions in 
//              the Un32_1 module of math32.lib
//************************************************************
// Library functions
extern "C" BIN_TO_ASC10(); // 16-bit binary into 5-digit ASCII decimal
extern "C" BIN_TO_ASC16(); // 16-bit binary into 4-digit ASCII hex
extern "C" ASCII_TO_DX();  // 4-digit ASCII decimal to binary in DX
extern "C" BINF_TO_DECF(); // 8-bit binary to 8-digit decimal fraction
extern "C" DECODE_SINGLE();// Isolate elements of single precision
extern "C" BIN_TO_BCD();   // 16-bit binary to 5 BCD digits
extern "C" BCD_TO_ASCII(); // 5 unpacked BCD to 5 ASCII digits
extern "C" BCD_INTO_REG(); // 5-digit BCD into a binary in DX
extern "C" BCD12_TO_ASCSTR();// BCD12 number in ASCII string
extern "C" ASCII_TO_BCD12(); // ASCII decimal string into BCD12 format
extern "C" ASCII_TO_EDX(); // ASCII to binary in EDX register

//**************************************************************
//                       Prototypes
//**************************************************************
void BinToAsc10(int, char[]);
void BinToAsc16(int, char[]);
int AsciiToInt(char[]);

//**************************************************************
//            C++ interface functions to Un32_1 module
//**************************************************************
void BinToAsc10(int value, char buffer[])
{
	_asm
    {
        MOV      EAX,value
        MOV      EDI,buffer
		CALL     BIN_TO_ASC10
		NOP
	}
  return;
}

void BinToAsc16(int value, char buffer[])
{
	_asm
    {
        MOV      EAX,value
        MOV      EDI,buffer
		CALL     BIN_TO_ASC16
		NOP
	}
  return;
}

int AsciiToInt(char buffer[])
{
int aVal = 0;
	_asm
    {
        MOV      ESI,buffer
		CALL     ASCII_TO_DX
		AND      EDX,0FFFFH
		MOV      aVal,EDX     
	}
  return aVal;
}