//************************************************************
//        Testing math transcendental primitives
//************************************************************
// Reference:   SOFTWARE SOLUTIONS
// Workspace  : Chapter6\Test Mu32_5
// Entry point: Test Mu32_5
// Other files: Un32_5.lib
//              Un32_5.h
// Development: Visual C++ 6.0 Console Application
// Date:        January 12/2001
//
// Description:
//              Tests for conversion transcendental functions
//              in the Un32_5 module of math32.lib
//              Tested functions:
//************************************************************
#include "stdafx.h"
#include "Un32_5.h"
#include <iostream.h>


int main()
{

   // Variables for tests
   int menuOption = 1;
   int exponent = 0;
   unsigned long result = 0;
   unsigned int y;
   double x, x2y, fy, fx;
   double logEVal, log10Val;
   double ne, n10;  

   // Set width and precesion
   cout.precision(20);       // Max     
   cout.width(20);           // Max

  while(menuOption)
  { 
    // Display menu
	cout << "FUNCTION TEST MENU\n"
         << "  0 = END TEST\n"
		 << "  1 = TenToYByFac()\n"
		 << "  2 = XtoYByFac()\n"
		 << "  3 = XtoYByBP()\n"
		 << "  4 = XtoYByLog()\n"
		 << "  5 = XtoYMixed()\n"
		 << "  6 = LogE() and Log10()\n"
         << "  7 = AlogE() and Alog10()\n"
		 << " SELECT: ";
    cin >> menuOption;
	
	switch(menuOption)
	{

    case 1:
    // TenToYByFac()
    cout << "\nTesting TenToYByFac()";
	cout << "\nEnter y (range for long is 0 to 9): ";
	cin >> exponent;
    result = TenToYByFac(exponent); 
	cout << "10 to y is: " << result << "\n";
	break;

	case 2:
	// XtoYByFac() 
    cout << "\nTesting XToYByFac()";
	cout << "\nEnter x : ";
	cin >> x;
	cout << "Enter y (positive integer): ";
	cin >> y;
    x2y = XToYByFac(x, y); 
	cout << "x to y is: " << x2y << "\n\n";
	break;

	case 3:
	// XtoYByBP() 
    cout << "\nTesting XToYByBP()";
	cout << "\nEnter x : ";
	cin >> x;
	cout << "Enter y (positive integer): ";
	cin >> y;
    x2y = XToYByBP(x, y); 
	cout << "x to y is: " << x2y << "\n\n";
    break;

	case 4:
	// XtoYByLog() 
    cout << "\nTesting XToYByLog()";
	cout << "\nEnter x : ";
	cin >> x;
	cout << "Enter y : ";
	cin >> fy;
    x2y = XToYByLog(x, fy); 
	cout << "x to y is: " << x2y << "\n\n";
    break; 

    case 5:
	// XtoYMixed() 
    cout << "\nTesting XToYMixed()";
	cout << "\nEnter x : ";
	cin >> x;
	cout << "Enter y : ";
	cin >> fy;
    x2y = XToYMixed(x, fy); 
	cout << "x to y is: " << x2y << "\n\n";
    break;

	case 6:
	// LogE() and Log10() 
    cout << "\nTesting LogE() and Log10()";
	cout << "\nEnter x : ";
	cin >> fx;
    logEVal = LogE(fx); 
    log10Val = Log10(fx);
	cout << "Log E of x is: " << logEVal << "\n";
	cout << "Log 10 of x is: " << log10Val << "\n\n";
    break;
	
	case 7:
	// Testing AlogE() and Alog10()
	cout << "\nTesting AlogE() and Alog10()";
    ne = AlogE(logEVal);
	n10 = Alog10(log10Val);
	cout << "\nNumber whose base E log is: " << logEVal;
    cout << " is: " << ne;
	cout << "\nNumber whose base 10 log is: " << log10Val;
    cout << " is: " << n10 << "\n\n";
	break;
	}
  }
	return 0;
}

