//************************************************************
//        Testing math transcendental primitives
//************************************************************
// Reference:   SOFTWARE SOLUTIONS
// Workspace  : Chapter6\Test Mu32_6
// Entry point: Test Mu32_6
// Other files: Un32_6.asm
//              Un32_6.h
// Development: Visual C++ 6.0 Console Application
// Date:        January 12/2001
//
// Description:
//              Tests for trigonometric transcendental functions
//              in the Un32_6 module of math32.lib
//************************************************************
#include "stdafx.h"
#include "Un32_6.h"
#include <iostream.h>
#include <conio.h>
#include <stdio.h>
#include <iomanip.h>

// Prototype
void WaitEOL();


int main()
{

// Variables for tests
double inVal = 30;
double outVal;
double outVal2;
double tFun, tFun1, tFun2;
double radAng, degAng;

    // Set width and precesion
    cout.precision(20);       // Max     
    cout.width(20);           // Max

    // DegToRad()
    cout << "\nTesting DegToRad() and RadToDeg()";
	cout << "\nEnter degrees: ";
	cin >> inVal;
    outVal = DegToRad(inVal); 
	cout << "Radians: " << outVal << "\n";

	// RadToDeg()
	cout << "Converting radians back to degrees";
    outVal2 = RadToDeg(outVal);
	cout << "\nDegrees: " << outVal2 << "\n";

	// Tangent(), Sine(), and Cosine() 
	cout << "\nTesting Tangent(), Sine(), and Cosine()";
    outVal = DegToRad(inVal);
	tFun = Tangent(outVal);
	tFun1 = Sine(outVal);
	tFun2 = Cosine(outVal);
	cout << "\nTangent: " << tFun;
	cout << "\nSine   : " << tFun1;
	cout << "\nCosine : " << tFun2 << "\n";

	// CoTangent(), Secant(), and CoSecant() 
	cout << "\nTesting CoTangent(), Secant(), and Cosecant()";
	tFun = CoTangent(outVal);
	tFun1 = Secant(outVal);
	tFun2 = CoSecant(outVal);
	cout << "\nCoTangent : " << tFun;
	cout << "\nSecant  : " << tFun1;
	cout << "\nCosecant: " << tFun2 << "\n";

    WaitEOL();

	// ArcTangent(), ArcSine(), and ArcCosine()
	cout << "\nTesting ArcTangent(), ArcSine(), and ArcCosine()";
	tFun = Tangent(outVal);
    radAng = ArcTangent(tFun);
	degAng = RadToDeg(radAng);
	cout << "\nTangent     : " << tFun;
	cout << "\nArc tangent : " << degAng;
	
	tFun = Sine(outVal);
    radAng = ArcSine(tFun);
	degAng = RadToDeg(radAng);
	cout << "\nSine       : " << tFun;
	cout << "\nArc sine   : " << degAng;

	tFun = Cosine(outVal);
    radAng = ArcCosine(tFun);
	degAng = RadToDeg(radAng);
	cout << "\nCosine     : " << tFun;
	cout << "\nArc cosine : " << degAng;

	WaitEOL();

	// Sinh(), Cosh(), and Tanh() 
	cout << "\nTesting Sinh(), Cosh(), and Tanh()";
	tFun = Sinh(outVal);
	cout << "\nHyperbolic sine    : " << tFun;
	tFun = Cosh(outVal);
	cout << "\nHyperbolic cosine  : " << tFun;
	tFun = Tanh(outVal);
	cout << "\nHyperbolic tangent : " << tFun;
    
	// ArcSinh(), ArcCosh(), and ArcTanh()
	cout << "\n\nTesting ArcSinh(), ArcCosh(), and ArcTanh()";
	// Sinh()/ArcSinh()
	tFun = Sinh(outVal);
    radAng = ArcSinh(tFun);
	degAng = RadToDeg(radAng);
	cout << "\nArc Hyperbolic sine of " << tFun;
	cout << " is: " << degAng << " degrees";
	// Cosh()/ ArcCosh()
	tFun = Cosh(outVal);
    radAng = ArcCosh(tFun);
	degAng = RadToDeg(radAng);
	cout << "\nArc Hyperbolic cosine of " << tFun;
	cout << " is: " << degAng << " degrees";	
	// Tanh()/ArcTanh()
	tFun = Tanh(outVal);
    radAng = ArcTanh(tFun);
	degAng = RadToDeg(radAng);
	cout << "\nArc Hyperbolic tangent of " << tFun;
	cout << " is: " << degAng << " degrees";

	cout << "\n\n";
	return 0;
}


void WaitEOL()
{
char dummy = 0;
    cout << "\n\nPress any key to continue...";
    cout << flush;                // flush the stream
	// Read input
	dummy = getch();
	return;
}
