;*****************************************************************
;*****************************************************************
;                           TEST_PLT.ASM
;*****************************************************************
;*****************************************************************
; Description:
;           Test and demonstration program for the EQUATION_PLOT
;           procedure in the UNIT_8 module of the MATHUNIT library
;
;*****************************************************************
EXTRN   DOS_STRING_OUT: FAR
EXTRN   KBR_WAIT:       FAR
EXTRN   INPUT_NUMBER:   FAR
EXTRN   OUTPUT_NUMBER:  FAR
EXTRN   SET_VIDEO_MODE: FAR
EXTRN   BRESENHAM:      FAR
EXTRN   SET_WRITE_MODE: FAR
EXTRN   EQUATION_PLOT:  FAR
EXTRN   DO_4_QUADS:     FAR
EXTRN   ES_TO_VIDEO:    FAR
EXTRN   CLS_18:         FAR
;
INCLUDELIB MATHUNIT
INCLUDELIB SOLUTION
;****************************************************************
;                          stack segment
;****************************************************************
STACK  SEGMENT stack

               DB      0400H DUP ('?'); Default stack is 1K
STACK_TOP      EQU     THIS BYTE
;
STACK  ENDS
;
;****************************************************************
;                          data segment
;****************************************************************
DATA    SEGMENT
;
EQ_MES  DB      'EQUATION PLOTTER',0AH,0DH
        DB      0AH,0DH,'Enter equation: $'

XL_MES  DB      0AH,0DH,'Enter limit of x coordinate: $'
;
; Numeric data storage
XL_VALUE        DW      0       ; Storage for high limit of
                                ; x coordinate
;
DOS_BUF         DB      60      ; 60 characters maximum
                DB      0       ; Input counter
EQU_STRING      DB      60 DUP (0H)
;
DATA    ENDS
;
;****************************************************************
;                          code segment
;****************************************************************
;
CODE    SEGMENT
        ASSUME  CS:CODE

START:
;*******************|
;  initialization   |
;*******************|
; Establish data and extra segment addressability
        MOV     AX,DATA         ; Address of DATA to AX
        MOV     DS,AX           ; and to DS
        ASSUME  DS:DATA         ; Assume from here on
;***********************************|
;           program code            |
;***********************************|
        LEA     DX,EQ_MES       ; Pointer to text message
        CALL    DOS_STRING_OUT  ; Library procedure
        FINIT
        LEA     DX,DOS_BUF      ; Pointer to input buffer
        MOV     AH,10           ; DOS service number
        INT     21H
; At this point the equation is in EQU_STRING
; Replace 0DH in buffer with 0H
        MOV     DI,DX           ; To index register
        INC     DI              ; DI --> start of data area
        MOV     AL,[DI]         ; Number of characters input
        INC     DI              ; Point to start of bufffer
        MOV     AH,0            ; Clear high byte
        ADD     DI,AX           ; Add input length
        MOV     BYTE PTR [DI],0 ; Replace 0DH with 0H
; Get high limit of range of the independent variable
        LEA     DX,XL_MES       ; Pointer to text message
        CALL    DOS_STRING_OUT  ; Library procedure
        CALL    INPUT_NUMBER    ; Input super procedure
        FISTP   XL_VALUE        ; Store in memory
;***********************************|
;             graphics              |
;***********************************|
        CALL    ES_TO_VIDEO
; ES --> start of video buffer in graphics mode
; Initialize 8087 hardware component
        FINIT
        MOV     AL,18           ; VGA 640-by-480 pixels
        CALL    SET_VIDEO_MODE  ; in 16 colors
        MOV     AL,2            ; Write mode
        CALL    SET_WRITE_MODE
        MOV     AL,00000111B    ; Grey color bit pattern
        CALL    CLS_18          ; Clear screen to gray
;
;***************************|
;        black lines        |
;***************************|
; Leave 60 pixels clear on the horizontal axis
;          AL = color of line
;          BX = start point x coordinate
;          CX = start point y coordinate
;          SI = end point x coordinate
;          DI = end point y coordinate
        MOV     BX,60
        MOV     CX,240
        MOV     SI,580
        MOV     DI,240
        MOV     AL,00000000B    ; Black
        CALL    BRESENHAM
;
; Leave 30 pixels clear on vertical axis
        MOV     BX,320
        MOV     CX,30
        MOV     SI,320
        MOV     DI,450
        MOV     AL,00000000B    ; Black
        CALL    BRESENHAM
;
        LEA     SI,EQU_STRING
        FILD    XL_VALUE
        CALL    EQUATION_PLOT
;
;           AL = color code in IRGB format (for mode 18)
;           BX = x coordinate of origin
;           CX = y coordinate of origin
        MOV     BX,320
        MOV     CX,240
        MOV     AL,00000100B    ; Red
        CALL    DO_4_QUADS

        CALL    KBR_WAIT
;************************|
;     DOS exit           |
;************************|
DOS_EXIT:
        MOV     AL,7
        CALL    SET_VIDEO_MODE  ; in 16 colors
        MOV     AH,4CH          ; DOS service request code
        MOV     AL,0            ; No error code returned
        INT     21H             ; TO DOS

CODE    ENDS
        END     START

  AL,0     