;*****************************************************************
;*****************************************************************
;                           TEST_TRG.ASM
;*****************************************************************
;*****************************************************************
; Description:
;            Test and demonstration program for the trigonometric
;            procedures in the UNIT_6 module of the MATHUNIT
;            library
;
;*****************************************************************
EXTRN   INPUT_NUMBER:   FAR
EXTRN   OUTPUT_NUMBER:  FAR
EXTRN   DEG_TO_RAD:     FAR
EXTRN   RAD_TO_DEG:     FAR
EXTRN   TANGENT:        FAR
EXTRN   SINE:           FAR
EXTRN   COSINE:         FAR
EXTRN   ARC_TANGENT:    FAR
EXTRN   COTANGENT:      FAR
;
INCLUDELIB MATHUNIT
INCLUDELIB SOLUTION
;****************************************************************
;                          stack segment
;****************************************************************
STACK  SEGMENT stack

               DB      0400H DUP ('?'); Default stack is 1K
STACK_TOP      EQU     THIS BYTE
;
STACK  ENDS
;
;****************************************************************
;                          data segment
;****************************************************************
DATA    SEGMENT
;
ANGLE_MESS      DB      0AH,0DH,'Enter angle: $'
RESULT_MESS     DB      0AH,0DH,'tangent / sine / cosine/ '
                DB      'cotangent / angle'
                DB      0AH,0DH,'$'
;
ENTRY_ANGLE     DT      0       ; Storage for input angle
                                ; during tests
FUNCTION        DT      0       ; Storage for function
DATA    ENDS
;
;****************************************************************
;                          code segment
;****************************************************************
;
CODE    SEGMENT
        ASSUME  CS:CODE
.386

START:
;*******************|
;  initialization   |
;*******************|
; Establish data and extra segment addressability
        MOV     AX,DATA         ; Address of DATA to AX
        MOV     DS,AX           ; and to DS
        ASSUME  DS:DATA         ; Assume from here on
;***********************************|
;           program code            |
;***********************************|
        FINIT                   ; Init FPU
;
; Display base input message
        LEA     DX,ANGLE_MESS   ; Prompt
        MOV     AH,9
        INT     21H
        CALL    INPUT_NUMBER
        LEA     DX,RESULT_MESS  ; Message
        MOV     AH,9
        INT     21H
; Angle in degrees in ST(0)
        CALL    DEG_TO_RAD      ; Convert to radian
        FSTP    ENTRY_ANGLE     ; Store angle
        FWAIT
; Tangent
        FLD     ENTRY_ANGLE
        CALL    TANGENT
        FSTP    FUNCTION
        FWAIT
        FLD     FUNCTION
        CALL    OUTPUT_NUMBER
; Sine
        FLD     ENTRY_ANGLE
        CALL    SINE
        CALL    OUTPUT_NUMBER
; Cosine
        FLD     ENTRY_ANGLE
        CALL    COSINE
        CALL    OUTPUT_NUMBER
; Cotangent
        FLD     ENTRY_ANGLE
        CALL    COTANGENT
        CALL    OUTPUT_NUMBER
; Get arc tangent
        FLD     FUNCTION
        CALL    ARC_TANGENT
        CALL    RAD_TO_DEG
        CALL    OUTPUT_NUMBER
;
;*******************|
;   exit to DOS     |
;*******************|
DOS_EXIT:
        MOV     AH,4CH          ; DOS service request code
        MOV     AL,0            ; No error code returned
        INT     21H             ; TO DOS
;

CODE    ENDS
        END     START           ; Reference to label at which
                                ; execution begins

    ENDS
        END     START           ; Reference to label at which
            